﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
Sub Class_Globals
	
	Type CharacterClassType(Value As Int, Description As String, RegexValue As String)
	Type CharacterClassValue(CharacterType As CharacterClassType, Count As Int)
	Public ccAny As CharacterClassType
	Public ccTab As CharacterClassType
	Public ccQuote As CharacterClassType
	Public ccAlphaNum As CharacterClassType
	Public ccNotAlphaNum As CharacterClassType
	Public ccDigit As CharacterClassType
	Public ccNonDigit As CharacterClassType
	Public ccSpace As CharacterClassType
	Public ccNonSpace As CharacterClassType
	
	Public ccCR As CharacterClassType
	Public ccCRLF As CharacterClassType
	Public ccNewLine As CharacterClassType
	Public ccAnyNewLine As CharacterClassType
		
	Public ucUpper As CharacterClassType
	Public ucLower As CharacterClassType
	Public ucLetter As CharacterClassType
	Public ucPunct As CharacterClassType
	Public ucControl As CharacterClassType
	Public ucNumber As CharacterClassType
	Public ucOpeningBrackets As CharacterClassType
	Public ucClosingBrackets As CharacterClassType
	Public ucSymbol As CharacterClassType
	Public ucMathSymbol As CharacterClassType
	Public ucCurrency As CharacterClassType

	Public SymCopyright As CharacterClassType
	Public SymTradeMark As CharacterClassType
	Public SymYen As CharacterClassType
	Public SymPound As CharacterClassType
	Public SymCent As CharacterClassType
	Public SymDegree As CharacterClassType
	Public SymPlusMinus As CharacterClassType
	Public SymSquare As CharacterClassType
	Public SymMu As CharacterClassType
	Public SymQuarter As CharacterClassType
	Public SymHalf As CharacterClassType
	Public SymThreeQuarters As CharacterClassType

  Type NamedRangeType(Value As Int, Description As String, RegexValue As String)	
	Public RngAbcLower As NamedRangeType
	Public RngAbcUpper As NamedRangeType
	Public RngAbcLowerUpper As NamedRangeType
	Public RngDigits As NamedRangeType
	Public RngAlpahnumeric As NamedRangeType
	Public RngLowerAlpahnumeric As NamedRangeType
	Public RngUpperAlpahnumeric As NamedRangeType
	Public RngSentenceEndMarkers As NamedRangeType
	Public RngWord As NamedRangeType
	Public RngPunctuation As NamedRangeType
	
	Public Const QtyAtLeast As Int = -1
	Public Const QtyAny As Int = -2
	Public Const QtyKeepIntact As Int = -3
	Private QtyUndefined As Int = -4
	Type QtyBehavior(Value As Int, Description As String, RegexValue As String)
	Type TQty(Minimum As Int, Maximum As Int)
	Public QtyStopAtFirstChance As QtyBehavior
	Public QtyRepeatTillLastMatch As QtyBehavior
	Public QtyBehaviorKeepIntact As QtyBehavior
	Public QtyBehaviorUndefined As QtyBehavior
	
	Type GroupType(Value As Int, Description As String, RegexValue As String)
	Public GrpRegular As GroupType
	Public GrpBacktrackOver As GroupType
	Public GrpPositiveLookAhead As GroupType
	Public GrpNegativeLookAhead As GroupType
	Public GrpPositiveLookBehind As GroupType
	Public GrpNegativeLookBehind As GroupType
	Public GrpCountedLookBehind As GroupType
	Public GrpNotCapturing As GroupType

	Type BoundaryType(Value As Int, Description As String, RegexValue As String)
	Public BndWord As BoundaryType
	Public BndWord As BoundaryType
	Public BndNotWord As BoundaryType
	Public BndPrevMatch As BoundaryType
	
	Private Const AnToAbsStart As Int = 1
	Private Const AnToOptStart As Int = 2
	Private Const AnToAbsEnd As Int = 3
	Private Const AnToOptEnd As Int = 4
		
	Private Const SetStart As Int = 5
	Private Const SetEnd As Int = 6
	Private Const SetSeparator As Int = 7
	Private Const SetNegate As Int = 8
	Private Const IntersectingSetStart As Int = 9
	
	Private Const CountAny As Int = 10
	Private Const CountOptional As Int = 11
	Private Const CountAtLEastOne As Int = 12
	Private Const CountStart As Int = 13
	Private Const CountSeparator As Int = 14
	Private Const CountEnd As Int = 15
	Private Const CountLazy As Int = 16
	
	Private Const GrpStart As Int = 17
	Private Const GrpEnd As Int = 18

	Private Const AltOr As Int = 19

	Private Metacharacters As String 'Assigned with the Regex vocabuulary so we keep everything in one place.
	Private MetacharactersInSets As String 'Assigned with the Regex vocabuulary so we keep everything in one place.
	  
	Private FIgnoreCase As Int
	Private FMultiline As Int
	Private FAnchorToStart As Boolean
	Private FAnchorToEnd As Boolean

  Type TreeNode(Name As String, Value As Object, Contents As List)	
	
	'When introducing a new type, also update: Nodes\NodeClass, Visualization\NodeValueToString, Translation\NodeRegexPattern, Nodes\CopyNodeValue	
	Type CharacterClass(Value As CharacterClassValue)
	Type Range(First As String, Last As String)
	Type NamedRange(Value As NamedRangeType, Exclude As Boolean)
	Type Set(Exclude As Boolean)
	Type IntersectingSet(Exclude As Boolean) 'Exclude is a dummy, can't have an empty Type. All intersecting ranges exclude.
	Type Counter(Minimum As Int, Maximum As Int, Lazy As QtyBehavior)
	Type Group(GroupType As GroupType, Minimum As Int, Maximum As Int)
	Type Boundary(BoundaryType As BoundaryType)
	Type OrClause(Single As Boolean)
	Private Const clsText As String = "Text"
	Private Const clsCharacterClass As String = "CharacterClass"
	Private Const clsRange As String = "Range"
	Private Const clsNamedRange As String = "NamedRange"
	Private Const clsSet As String = "Set"
	Private Const clsIntersectingSet As String = "IntersectingSet"
	Private Const clsCounter As String = "Counter"
	Private Const clsGroup As String = "Group"
	Private Const clsBoundary As String = "Boundary"
	Private Const clsOrClause As String = "OrClause"

	Private RegexVocabularyMap As Map
	
	Private InvalidNode As TreeNode
	Private InvalidName As String = "-2147483648"
	
	Private Tree As TreeNode	
  Private FlatList As List	
	Private NodeStack As List
	Private NodeStatus As List
End Sub

#Region Initialize

Public Sub Initialize(IgnoreCase As Boolean, SearchLineByLine As Boolean, MustMatchAtStart As Boolean, MustEndWithMatch As Boolean) As RegexConstructor
	InitializeRegexVocabularyMap
	InitializeParameters
	InvalidNode = CreateNode(InvalidName, InvalidName)
	NodeStatus.Initialize	
	Return Reset(IgnoreCase, SearchLineByLine, MustMatchAtStart, MustEndWithMatch)
End Sub

Private Sub InitializeRegexVocabularyMap
	Metacharacters = "[\^$.|?*+()"
	MetacharactersInSets = "\^-]" 'The order is important, backslash must be the first character!
	
	RegexVocabularyMap.Initialize
	RegexVocabularyMap.Put(AnToAbsStart, "\A")
	RegexVocabularyMap.Put(AnToOptStart, "^")
	RegexVocabularyMap.Put(AnToAbsEnd, "\Z")
	RegexVocabularyMap.Put(AnToOptEnd, "$")
		
	RegexVocabularyMap.Put(SetStart, "[")
	RegexVocabularyMap.Put(SetEnd, "]")
  RegexVocabularyMap.Put(SetSeparator, "-")	
	RegexVocabularyMap.Put(SetNegate, "^")	
	RegexVocabularyMap.Put(IntersectingSetStart, "&&[^")	
	
	RegexVocabularyMap.Put(CountAny, "*")
	RegexVocabularyMap.Put(CountOptional, "?")
	RegexVocabularyMap.Put(CountAtLEastOne, "+")
	RegexVocabularyMap.Put(CountStart, "{")
	RegexVocabularyMap.Put(CountSeparator, ",")
	RegexVocabularyMap.Put(CountEnd, "}")
	RegexVocabularyMap.Put(CountLazy, "?")
	
	RegexVocabularyMap.Put(GrpStart, "(")
	RegexVocabularyMap.Put(GrpEnd, ")")

	RegexVocabularyMap.Put(AltOr, "|")

End Sub

Private Sub InitializeParameters
	BndWord = CreateBoundaryType(1, "Match at word boundary", "\b")
	BndNotWord = CreateBoundaryType(2, "Match not word boundary", "\B")
	BndPrevMatch = CreateBoundaryType(3, "Previous match End", "\G")
	
	QtyStopAtFirstChance = CreateQtyBehavior(2, "Stop at first chance", "?")
	QtyRepeatTillLastMatch = CreateQtyBehavior(1, "Repeat till last match", "")

	GrpRegular = CreateGroupType(0, "Simple group", "")
	GrpBacktrackOver = CreateGroupType(1, "Backtracking will pass over", "?>")
	GrpPositiveLookAhead = CreateGroupType(2, "Positive lookahead", "?=")
	GrpNegativeLookAhead = CreateGroupType(3, "Negative lookahead", "?!")
	GrpPositiveLookBehind = CreateGroupType(4, "Positive lookbehind", "?<=")
	GrpNegativeLookBehind = CreateGroupType(5, "Negative lookbehind", "?<!")
	GrpCountedLookBehind = CreateGroupType(6, "Counted lookbehind", "?<=")
	GrpNotCapturing = CreateGroupType(7, "Group will not record", "?:")

	RngAbcLower = CreateNamedRangeType(1, "AbcLower", "a-z")
	RngAbcUpper = CreateNamedRangeType(2, "AbcUpper", "A-Z")
	RngAbcLowerUpper = CreateNamedRangeType(3, "AbcLowerUpper", "A-Za-z")
	RngDigits = CreateNamedRangeType(4, "Digits", "0-9")
	RngAlpahnumeric = CreateNamedRangeType(5, "Alphanum", "A-Za_z0-9")
	RngLowerAlpahnumeric = CreateNamedRangeType(6, "LowerAlphanum", "a_z0-9")
	RngUpperAlpahnumeric = CreateNamedRangeType(7, "UpperAlphaNum", "A_Z0-9")
	RngSentenceEndMarkers = CreateNamedRangeType(8, "SentenceEndMarkers", ".?!")
	RngWord = CreateNamedRangeType(9, "Word", $"${RngAbcLowerUpper}-'"$)
	RngPunctuation = CreateNamedRangeType(10,"Punctuation", $"!`()-;:'",./?"$)

	ccAny = CreateCharacterClassType(1, $"The "any" character"$, ".")
	ccTab = CreateCharacterClassType(2, "Tab"$, "\t")
	ccQuote = CreateCharacterClassType(3, "Quote"$, $"\""$)
	ccAlphaNum = CreateCharacterClassType(4, "Alphanumeric", "\w")
	ccNotAlphaNum = CreateCharacterClassType(5, "Not alphanumeric", "\W")
	ccDigit = CreateCharacterClassType(6, "Digit", "\d")
	ccNonDigit = CreateCharacterClassType(7, "Not digit", "\D")
	ccSpace = CreateCharacterClassType(8, "Space", "\s")
	ccNonSpace = CreateCharacterClassType(9, "Not space", "\S")
	
	ccCR = CreateCharacterClassType(10, "CR", "\r")
	ccCRLF = CreateCharacterClassType(11, "CRLF", "\r\n")
	ccNewLine = CreateCharacterClassType(12, "NL", "\n")
	ccAnyNewLine = CreateCharacterClassType(13, "AnyNewLine", "\R")
		
	ucUpper = CreateCharacterClassType(14, "uUpper", "\p{Lu}")
	ucLower = CreateCharacterClassType(15, "uLower", "\p{Ll}")
	ucLetter = CreateCharacterClassType(16, "uLetter", "\p{L}")
	ucPunct = CreateCharacterClassType(17, "uPunct", "\p{P}")
	ucControl = CreateCharacterClassType(18, "uCtrl", "\p{C}")
	ucNumber = CreateCharacterClassType(19, "uNum", "\p{N}")
	ucOpeningBrackets = CreateCharacterClassType(20, "uOpeningBrackets", "\p{Ps}")
	ucClosingBrackets = CreateCharacterClassType(21, "uClosingBrackets", "\p{Pe}")
	ucSymbol = CreateCharacterClassType(22, "uSym", "\p{S}") '+, -
	ucMathSymbol = CreateCharacterClassType(23, "uMath", "\p{Sm}")
	ucCurrency = CreateCharacterClassType(24, "uCurrency", "\p{Sc}")

	SymCopyright = CreateCharacterClassType(25, "symCopyright", "©")
	SymTradeMark = CreateCharacterClassType(26, "symTrademark", "®")
	SymYen = CreateCharacterClassType(27, "symYen", "¥")
	SymPound = CreateCharacterClassType(28, "symPound", "£")
	SymCent = CreateCharacterClassType(29, "symCent", "¢")
	SymDegree = CreateCharacterClassType(30, "symDegree", "°")
	SymPlusMinus = CreateCharacterClassType(31, "symPlusMinus", "±")
	SymSquare = CreateCharacterClassType(32, "symSquare", "²")
	SymMu = CreateCharacterClassType(33, "symMu", "µ")
	SymQuarter = CreateCharacterClassType(34, "symQuarter", "¼")
	SymHalf = CreateCharacterClassType(35, "symHalf", "½")
	SymThreeQuarters = CreateCharacterClassType(36, "symThreeQuarters", "¾")
	
End Sub

Private Sub CreateBoundaryType(Value As Int, Description As String, RegexValue As String) As BoundaryType
  Dim Result As BoundaryType
	Result.Initialize
	Result.Value = Value
	Result.Description = Description
	Result.RegexValue = RegexValue
	Return Result
End Sub

Private Sub CreateQtyBehavior(Value As Int, Description As String, RegexValue As String) As QtyBehavior
	Dim Result As QtyBehavior
	Result.Initialize
	Result.Value = Value
	Result.Description = Description
	Result.RegexValue = RegexValue
	Return Result
End Sub

Private Sub CreateGroupType(Value As Int, Description As String, RegexValue As String) As GroupType
  Dim Result As GroupType
	Result.Initialize
	Result.Value = Value
	Result.Description = Description
	Result.RegexValue = RegexValue
	Return Result
End Sub

Private Sub CreateCharacterClassType(Value As Int, Description As String, RegexValue As String) As CharacterClassType
	Dim Result As CharacterClassType
	Result.Initialize
	Result.Value = Value
	Result.Description = Description
	Result.RegexValue = RegexValue
	Return Result
End Sub

Private Sub CreateCharacterClassValue(ClassType As CharacterClassType, Count As Int) As CharacterClassValue
	Dim Result As CharacterClassValue
	Result.Initialize
	Result.CharacterType = ClassType
	Result.Count = Count
	Return Result
End Sub

Private Sub CreateNamedRangeType(Value As Int, Description As String, RegexValue As String) As NamedRangeType
	Dim Result As NamedRangeType
	Result.Initialize
	Result.Value = Value
	Result.Description = Description
	Result.RegexValue = RegexValue
	Return Result
End Sub

Public Sub Reset(IgnoreCase As Boolean, SearchLineByLine As Boolean, MustMatchAtStart As Boolean, MustEndWithMatch As Boolean) As RegexConstructor
	FIgnoreCase = IIf(IgnoreCase, Regex.CASE_INSENSITIVE, 0)
	FMultiline = IIf(SearchLineByLine, Regex.MULTILINE, 0)
	FAnchorToStart = MustMatchAtStart
	FAnchorToEnd = MustEndWithMatch
  Return Clear	
End Sub

Public Sub Clear As RegexConstructor
	Tree = CreateNode("TreeRoot", Null)
	Tree.Value = Tree
	FlatList.Initialize
	NodeStack.Initialize
	PushNode(Tree)
	Return Me
End Sub

#End Region

#Region Visualization

Private Sub NodeValueToString(N As TreeNode) As String
	Dim V As Object = N.Value
	If V Is String Then Return V
	If V Is CharacterClass Then Return $"${V.As(CharacterClass).Value.CharacterType.Description}, Count: ${V.As(CharacterClass).Value.Count})"$
	If V Is Range Then Return $"${V.As(Range).First} - ${V.As(Range).Last}"$
	If V Is NamedRange Then Return V.As(NamedRange).Value.Description
	If V Is Set Then Return $"Exclude = ${V.As(Set).Exclude}"$
	If V Is IntersectingSet Then Return "Exclude"
	If V Is Counter Then
		Dim c As Counter = V
		Return $"${CounterDisplay(c.Minimum)} - ${CounterDisplay(c.Maximum)}, ${c.Lazy.Description}"$
	End If	
	'Group(Capture As Boolean)
	If V Is Boundary Then Return V.As(Boundary).BoundaryType.Description
	If V Is OrClause Then Return "Or"
	Return ""
End Sub

Private Sub CounterDisplay(i As Int) As String
	Select i
		Case QtyAny 
			Return "Any"
		Case QtyAtLeast
			Return "At least"
		Case Else
			If i < 0 Then Return $"Invalid(${i}"$
			Return i
	End Select
End Sub

Private Sub NodeToString(N As TreeNode) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(IIf(N.Name = "", "No Name", N.Name)).Append(": ").Append(NodeClass(N)).Append(", Value: ").Append(NodeValueToString(N))
	Return sb.ToString
End Sub

Public Sub Visualize(tv As TreeView)
	tv.Root.Children.Clear
	AddToTreeView(tv.Root.Children, Tree.Contents)
End Sub

Private Sub AddToTreeView(Children As List, Contents As List)
	For Each N As TreeNode In Contents
		Dim ti As TreeItem
		ti.Initialize("", NodeToString(N))
		Children.Add(ti)
		AddToTreeView(ti.Children, N.Contents)
	Next
End Sub

#End Region

#Region Translation

Private Sub Voc(i As Int) As String
	Return RegexVocabularyMap.Get(i)
End Sub

Public Sub RegexPattern As String
	Dim sb As StringBuilder
	NodeStatus.Clear
	sb.Initialize
	If FAnchorToStart Then sb.Append(IIf(FMultiline, Voc(AnToOptStart), Voc(AnToAbsStart)))
	NodeRegexPattern(Tree, sb)
	If FAnchorToEnd Then sb.Append(IIf(FMultiline, Voc(AnToOptEnd), Voc(AnToAbsEnd)))
	Return sb.ToSTring
End Sub

Private Sub NodeRegexPattern(N As TreeNode, sb As StringBuilder)
	For Each ChildNode As TreeNode In N.Contents
		Dim V As Object = ChildNode.Value
		If V Is String Then
			sb.Append(IIf(InSet, LiteralInSet(V), Literal(V)))
		Else If V Is CharacterClass Then
      sb.Append(LiteralInSet(Multiple(V.As(CharacterClass).Value.CharacterType.RegexValue, V.As(CharacterClass).Value.Count)))
		Else If V Is Range Then
			Dim R As Range = V
			If OutsideSet Then sb.Append(Voc(SetStart))
			sb.Append(R.First).Append(Voc(SetSeparator)).Append(R.Last)
		Else If V Is NamedRange Then
			Dim NR As NamedRange = V
			If OutsideSet Then sb.Append(Voc(SetStart))
			sb.Append(NR.Value.RegexValue)
		Else If V Is Set Then
			If OutsideSet Then sb.Append(Voc(SetStart))
			If V.As(Set).Exclude Then sb.Append(Voc(SetNegate))
			NodeStatus.Add(clsSet)
			NodeRegexPattern(ChildNode, sb)
			PullNodeStatus
			If OutsideSet Then sb.Append(Voc(SetEnd))
		Else If V Is IntersectingSet Then
			sb.Append(Voc(IntersectingSetStart))
			NodeStatus.Add("IntersectingSet")
			NodeRegexPattern(ChildNode, sb)
			PullNodeStatus
			sb.Append(Voc(SetEnd))
		Else If V Is Counter Then
			NodeRegexPattern(ChildNode, sb)
			sb.Append(CounterToRegex(V))
		Else If V Is Group Then
			Dim Grp As Group = V
			sb.Append(Voc(GrpStart))
			sb.Append(V.As(Group).GroupType.RegexValue)
			NodeRegexPattern(ChildNode, sb)
			If Grp.GroupType = GrpCountedLookBehind Then sb.Append(Voc(CountStart)).Append(Grp.Minimum).Append(Voc(CountSeparator)).Append(Grp.Maximum).Append(Voc(CountEnd))
			sb.Append(Voc(GrpEnd))
		Else If V Is Boundary Then
			sb.Append(V.As(Boundary).BoundaryType.RegexValue)
			If ChildNode.Contents.Size > 0 Then
				NodeRegexPattern(ChildNode, sb)
				sb.Append(V.As(Boundary).BoundaryType.RegexValue)
			End If
		Else If V Is OrClause Then
			sb.Append(Voc(AltOr))
			If ChildNode.Contents.Size > 0 Then NodeRegexPattern(ChildNode, sb)
		End If
	Next
End Sub

Private Sub PullNodeStatus
	NodeStatus.RemoveAt(NodeStatus.Size - 1)
End Sub

Private Sub InSet As Boolean
	Return Not(OutsideSet)
End Sub

Private Sub OutsideSet As Boolean
	Return NodeStatus.IndexOf(clsSet) = -1 And NodeStatus.IndexOf(clsRange) = -1 And NodeStatus.IndexOf(clsIntersectingSet) = -1
End Sub

Private Sub FullCountPattern(Minimum As Int, Maximum As Int) As String
  Dim sb As StringBuilder
	sb.Initialize
	sb.Append(Voc(CountStart))	
	If Minimum > -1 Then sb.Append(Minimum)
	sb.Append(Voc(CountSeparator))
	If Maximum > 0 Then sb.Append(Maximum)
	sb.Append(Voc(CountEnd))
	Return sb.ToString
End Sub

Private Sub ResolveQuantity(Minimum As Int, Maximum As Int) As TQty
	Dim Result As TQty
	Result.Initialize  
	If Minimum < 1 And Maximum < 1 Then
		Minimum = 0
		Maximum = QtyAny
	Else If Minimum < 0 Then
		Minimum = Max(Minimum, QtyAny)
		Select Minimum
			Case QtyAny
				Minimum = 0
			Case QtyAtLeast
        Select Maximum
				  Case 0
					  Maximum = QtyAny
					Case Else
						Minimum = Maximum
						Maximum = QtyAny														
        End Select
		End Select
		Result.Minimum = Minimum
		Result.Maximum = Maximum
		Return Result
	End If
	Maximum = Max(Maximum, QtyAny)
	If Maximum > -1 And Maximum < Minimum Then
		Result.Minimum = Maximum
		Result.Maximum = Minimum
	Else
		Result.Minimum = Minimum
		Result.Maximum = Maximum	
	End If
	Return Result
End Sub

Private Sub CounterToRegex(C As Counter) As String
	'If InGroup Then GrpEnd
	Dim sb As StringBuilder
	sb.Initialize
	If C.Minimum = C.Maximum Then
		sb.Append(Voc(CountStart)).Append(C.Minimum).Append(Voc(CountEnd))
	Else
		Select C.Minimum
			Case 0
				Select C.Maximum
					Case QtyAny
						sb.Append(Voc(CountAny))
					Case 1
						sb.Append(Voc(CountOptional))
					Case Else
						sb.Append(FullCountPattern(C.Minimum, C.Maximum))
				End Select
			Case Else
				If C.Maximum = QtyAny Then sb.Append("+") Else sb.Append(FullCountPattern(C.Minimum, C.Maximum))
		End Select
	End If
	Return sb.Append(C.Lazy.RegexValue).ToString
End Sub

Private Sub LiteralInSet(SetText As String) As String	
	For i = 0 To MetacharactersInSets.Length - 1
		SetText = SetText.Replace(MetacharactersInSets.CharAt(i), "\" & MetacharactersInSets.CharAt(i))
	Next
	Return SetText
End Sub

Private Sub Literal(Text As String) As String	
	If Text.Length = 0 Then Return ""
	Dim i As Int
	Dim Block As Boolean = False
	Dim c As Char
	Dim Count As Int = 0
	For i = 0 To Metacharacters.Length - 1
		c = Metacharacters.CharAt(i)
		For ti = 0 To Text.Length - 1
			If c = Text.CharAt(ti) Then Count = Count + 1
			If Count > 3 Then
				Block = True
				Exit
			End If
		Next
		If Block Then Exit
	Next
	If Block = False Then
		For i = 0 To Metacharacters.Length - 1
			Text = Text.Replace(Metacharacters.CharAt(i), "\" & Metacharacters.CharAt(i))
		Next
		Return Text
	End If
	i = Text.IndexOf("\E")
	If i = -1 Then Return "\Q" & Text & "\E"
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("\Q")
	Dim Start As Int = 0
	Do While i > -1
		sb.Append(Text.SubString2(Start, i))
		sb.Append("\E\\E\Q")
		Start = i + 2
		i = Text.IndexOf2("\E", Start)
	Loop
	sb.Append(Text.SubString(Start)).Append("\E")
	Return sb.ToString
End Sub

#End Region

#Region Execute

'Like Regex.IsMatch, but uses the internal Pattern.
'Just pass the text to be searched.
'This anchores the match to the text start and end, not for finding matches inside the text!
'Also see HasMatch.
Public Sub ExIsMatch(Txt As String) As Boolean
	Try
		Return Regex.IsMatch2(RegexPattern, Options, Txt)
	Catch
		RCLog($"ExIsMatch: ${LastException.Message}"$, False)
		Return False
	End Try
End Sub

'Like Regex.IsMatch2, but uses the internal Pattern.
'Options are simplified with two Boolean values.
'Just pass the text to be searched.
'This anchores the match to the text start and end, not for finding matches inside the text!
'Also see HasMatch.
Public Sub ExIsMatch2(Txt As String, IgnoreCase As Boolean, Multiline As Boolean) As Boolean
	Try
		Return Regex.IsMatch2(RegexPattern, RegexOptions(IgnoreCase, Multiline), Txt)
	Catch
		RCLog($"ExIsMatch2: ${LastException.Message}"$, False)
		Return False
	End Try
End Sub

'Like Regex.IsMatch, but
'1) Uses the internal pattern.
'2) Unlike IsMatch, returns True if the match is inside the text somewhere.
'Options are simplified with two Boolean values.
'Just pass the text to be searched.
Public Sub ExHasMatch(Txt As String) As Boolean
	Try
		Dim m As Matcher = ExMatcher(Txt)
		If Not(m.IsInitialized) Then Return 0
		Return m.Find
	Catch
		RCLog($"ExHasMatch: ${LastException.Message}"$, False)
		Return False
	End Try
End Sub

'Like Regex.IsMatch2, but
'1) Uses the internal pattern.
'2) Unlike IsMatch, returns True if the match is inside the text somewhere.
'Options are simplified with two Boolean values.
'Just pass the text to be searched.
Public Sub ExHasMatch2(Txt As String, IgnoreCase As Boolean, Multiline As Boolean) As Boolean
	Try
		Dim m As Matcher = ExMatcher2(Txt, IgnoreCase, Multiline)
		If Not(m.IsInitialized) Then Return 0
		Return m.Find
	Catch
		RCLog($"ExHasMatch2: ${LastException.Message}"$, False)
		Return False
	End Try
End Sub

'Counts the number of matches. 
'Matching is done with the internal pattern.
'Just pass the text to be searched.
Public Sub ExMatchCount(Txt As String) As Int
	Dim m As Matcher = ExMatcher(Txt)
	If Not(m.IsInitialized) Then Return 0
	Dim Result As Int = 0
	Do While m.Find
		Result = Result + 1
	Loop
	Return Result
End Sub

'Counts the number of matches.
'Matching is done with the internal pattern, with Regex options.
'Just pass the text to be searched.
Public Sub ExMatchCount2(Txt As String, IgnoreCase As Boolean, Multiline As Boolean) As Int
	Dim m As Matcher = ExMatcher2(Txt, IgnoreCase, Multiline)
	If Not(m.IsInitialized) Then Return 0
	Dim Result As Int = 0
	Do While m.Find
		Result = Result + 1
	Loop
	Return Result
End Sub

'Returns a list with the start indeces of matches.
'Matching is done with the internal pattern.
'Just pass the text to be searched.
Public Sub ExIndeces(Txt As String) As List
	Dim Result As List
	Result.Initialize
	Dim m As Matcher = ExMatcher(Txt)
	If Not(m.IsInitialized) Then Return Result
	Dim i As Int = 1
	Do While m.Find
		Result.Add(m.GetStart(i))
		i = i + 1
	Loop
	Return Result
End Sub

'Returns a list with the start indeces of matches.
'Matching is done with the internal pattern, with Regex options.
'Just pass the text to be searched.
Public Sub ExIndeces2(Txt As String, IgnoreCase As Boolean, Multiline As Boolean) As List
	Dim Result As List
	Result.Initialize
	Dim m As Matcher = ExMatcher2(Txt, IgnoreCase, Multiline)
	If Not(m.IsInitialized) Then Return Result
	Dim i As Int = 1
	Do While m.Find
		Result.Add(m.GetStart(i))
		i = i + 1
	Loop
	Return Result
End Sub

'Like Regex.Matcher, but with the internal Pattern.
'Just pass the text to be searched.
Public Sub ExMatcher(Txt As String) As Matcher
	Try
		Return Regex.Matcher2(RegexPattern, Options, Txt)
	Catch
		RCLog($"ExMatcher: ${LastException.Message}"$, False)
		Return Null
	End Try
End Sub

'Like Regex.Matcher2, but with the internal Pattern.
'Options are simplified with two Boolean values.
'Just pass the text to be searched.
Public Sub ExMatcher2(Txt As String, IgnoreCase As Boolean, Multiline As Boolean) As Matcher
	Try
		Return Regex.Matcher2(RegexPattern, RegexOptions(IgnoreCase, Multiline), Txt)
	Catch
		RCLog($"ExMatcher2: ${LastException.Message}"$, False)
		Return Null
	End Try
End Sub

'Like Regex.Replace, but with the internal Pattern and internal Template.
'Just pass the text to be searched.
Public Sub ExReplace(Txt As String) As String
	Try
		Return "" 'Regex.Replace(RegexPattern, Txt, RegexReplaceTemplate)
	Catch
		RCLog($"ExReplace: ${LastException.Message}"$, False)
		Return ""
	End Try
End Sub

'Like Regex.Replace2, but with the internal Pattern and internal Template.
'Options are simplified with two Boolean values.
'Just pass the text to be searched.
Public Sub ExReplace2(Txt As String, IgnoreCase As Boolean, Multiline As Boolean) As String
	Try
		Return "" ' Regex.Replace2(RegexPattern, GetOptions(IgnoreCase, Multiline), Txt, getReplaceTemplate)
	Catch
		RCLog($"ExReplace2: ${LastException.Message}"$, False)
		Return ""
	End Try
End Sub

'Like Regex.Replace, but with the internal Pattern.
'Just pass the text to be searched and the Replace Template.
Public Sub ExReplaceWith(Txt As String, Template As String) As String
	Try
		Return Regex.Replace2(RegexPattern, Options, Txt, Template)
	Catch
		RCLog($"ExReplaceWith: ${LastException.Message}"$, False)
		Return ""
	End Try
End Sub

'Like Regex.Replace2, but with the internal Pattern.
'Options are simplified with two Boolean values.
'Just pass the text to be searched and the Replace Template.
Public Sub ExReplaceWith2(Txt As String, IgnoreCase As Boolean, Multiline As Boolean, Template As String) As String
	Try
		Return Regex.Replace2(RegexPattern, RegexOptions(IgnoreCase, Multiline), Txt, Template)
	Catch
		RCLog($"ExReplaceWith2: ${LastException.Message}"$, False)
		Return ""
	End Try
End Sub

'Like Regex.Split, but with the internal Pattern and internal Splitter pattern.
'Set up a pattern the regular way and then call MovePatternToSplitter.
'Then set up the pattern for matching and call Split.
'Just pass the text to be searched and the Replace Template.
Public Sub ExSplit(Txt As String, RemoveBlanks As Boolean) As String()
	Try
		Dim lst As List
		lst.Initialize2(Regex.Split2(RegexPattern, Options, Txt))
		If RemoveBlanks Then
			For i = lst.Size - 1 To 0 Step -1
				If "" = lst.Get(i) Then lst.RemoveAt(i)
			Next
		End If
		Dim Result(lst.Size) As String
		For Each s As String In lst
			Result(i) = s
		Next
		Return Result
	Catch
		RCLog($"ExSplit: ${LastException.Message}"$, False)
		Return Null
	End Try
End Sub

'Like Regex.Split2, but with the internal Pattern and internal Splitter pattern.
'Set up a pattern the regular way and then call MovePatternToSplitter.
'Then set up the pattern for matching and call Split.
'Options are simplified with two Boolean values.
'Just pass the text to be searched and the Replace Template.
Public Sub ExSplit2(Txt As String, IgnoreCase As Boolean, Multiline As Boolean, RemoveBlanks As Boolean) As String()
	Try
		Dim lst As List
		lst.Initialize2(Regex.Split2(RegexPattern, RegexOptions(IgnoreCase, Multiline), Txt))
		If RemoveBlanks Then
			For i = lst.Size - 1 To 0 Step -1
				If "" = lst.Get(i) Then lst.RemoveAt(i)
			Next
		End If
		Dim Result(lst.Size) As String
		For Each s As String In lst
			Result(i) = s
		Next
		Return Result
	Catch
		RCLog($"ExSplit2: ${LastException.Message}"$, False)
		Return Null
	End Try
End Sub

Private Sub RCLog(Msg As String, Crash As Boolean)
	If Msg = "" Then Return
	Dim T As Long = DateTime.Now
	Log($"$1.0{DateTime.GetHour(T)}:$2.0{DateTime.GetMinute(T)}:$2.0{DateTime.GetSecond(T)}.$3.0{T Mod 1000} - RegexConstructor: ${Msg}"$)
	If Crash Then
		"a".As(String).SubString(-1)
	End If
End Sub

Private Sub Options As Int
  Return Bit.Or(FIgnoreCase, FMultiline)	
End Sub

Private Sub RegexOptions(IgnoreCase As Boolean, Multiline As Boolean) As Int
	Return Bit.Or(IIf(IgnoreCase, Regex.CASE_INSENSITIVE, 0), IIf(Multiline, Regex.MULTILINE, 0))
End Sub

#End Region

#Region Nodes

#Region Create 

Private Sub CreateCharacterClass(Value As CharacterClassValue) As CharacterClass
	Dim Result As CharacterClass
	Result.Initialize
	Result.Value = Value
	Return Result
End Sub

Private Sub CopyTCharacterClass(c As CharacterClass) As CharacterClass
	Return CreateCharacterClass(c.Value)
End Sub

Private Sub CreateCharacterClassNode(Name As String, Value As CharacterClassValue) As TreeNode
	Return CreateNode(Name, CreateCharacterClass(Value))
End Sub

Public Sub CreateRange(First As String, Last As String) As Range
	Dim Result As Range
	Result.Initialize
	Result.First = First
	Result.Last = Last
	Return Result
End Sub

Private Sub CopyTRange(r As Range) As Range
	Return CreateRange(r.First, r.Last)
End Sub

Private Sub CreateRangeNode(Name As String, First As String, Last As String) As TreeNode
	Return CreateNode(Name, CreateRange(First, Last))
End Sub

Private Sub CreateNamedRange(Value As NamedRangeType, Exclude As Boolean) As NamedRange
	Dim Result As NamedRange
	Result.Initialize
	Result.Value = Value
	Result.Exclude = Exclude
	Return Result
End Sub

Private Sub CopyTNamedRange(r As NamedRange) As NamedRange
	Return CreateNamedRange(r.Value, r.Exclude)
End Sub
	
Private Sub CreateNamedRangeNode(Name As String, Value As NamedRangeType, Exclude As Boolean)	As TreeNode
	Return CreateNode(Name, CreateNamedRange(Value, Exclude))
End Sub

Private Sub CreateSet(Exclude As Boolean) As Set
	Dim Result As Set
	Result.Initialize
	Result.Exclude = Exclude
	Return Result
End Sub

Private Sub CopyTSet(s As Set) As Set
	Return CreateSet(s.Exclude)
End Sub

Private Sub CreateSetNode(Name As String, Exclude As Boolean) As TreeNode
	Return CreateNode(Name, CreateSet(Exclude))
End Sub

Private Sub CreateIntersectingSet As IntersectingSet
	Dim Result As IntersectingSet
	Result.Initialize
	Result.Exclude = True
	Return Result
End Sub

Private Sub CreateIntersectingSetNode(Name As String) As TreeNode
	Return CreateNode(Name, CreateIntersectingSet)
End Sub

Private Sub CopyTIntersectingSet As IntersectingSet
	Return CreateIntersectingSet
End Sub

Private Sub CreateCounter(Minimum As Int, Maximum As Int, Lazy As QtyBehavior) As Counter
	Dim Result As Counter
	Dim tmp As TQty = ResolveQuantity(Minimum, Maximum)
	Result.Minimum = tmp.Minimum
	Result.Maximum = tmp.Maximum
	Result.Lazy = Lazy
	Return Result
End Sub

Private Sub CopyTCounter(c As Counter) As Counter
	Return CreateCounter(c.Minimum, c.Maximum, c.Lazy)
End Sub

Private Sub CreateCounterNode(Name As String, Minimum As Int, Maximum As Int, Lazy As QtyBehavior) As TreeNode
	Return CreateNode(Name, CreateCounter(Minimum, Maximum, Lazy))
End Sub

Private Sub CreateGroup(GroupType As GroupType, Minimum As Int, Maximum As Int) As Group
	Dim Result As Group
	Result.Initialize
	Result.GroupType = GroupType
	Result.Minimum = Minimum
	Result.Maximum = Maximum
	Return Result
End Sub

Private Sub CopyTGroup(g As Group) As Group
	Return CreateGroup(g.GroupType, g.Minimum, g.Maximum)
End Sub

Private Sub CreateGroupNode(Name As String, GroupType As GroupType, Minimum As Int, Maximum As Int) As TreeNode
	Return CreateNode(Name, CreateGroup(GroupType, Minimum, Maximum))
End Sub

Private Sub CreateBoundary(BoundaryType As BoundaryType) As Boundary
	Dim Result As Boundary
	Result.Initialize
	Result.BoundaryType = BoundaryType
	Return Result
End Sub

Private Sub CopyTBoundary(b As Boundary) As Boundary
	Return CreateBoundary(b.BoundaryType)
End Sub

Private Sub CreateBoundaryNode(Name As String, BoundaryType As BoundaryType) As TreeNode
	Return CreateNode(Name, CreateBoundary(BoundaryType))
End Sub

Private Sub CreateOrClause(Single As Boolean) As OrClause
	Dim Result As OrClause
	Result.Initialize
	Result.Single = Single
	Return Result
End Sub

Private Sub CreateOrNode(Name As String, Single As Boolean) As TreeNode
	Return CreateNode(Name, CreateOrClause(Single))
End Sub

Private Sub CopyTOrClause(O As OrClause) As OrClause
	Return CreateOrClause(O.Single)
End Sub

#End Region

Private Sub NodeClass(N As TreeNode) As String
	Dim V As Object = N.Value
	If V Is String Then Return clsText
	If V Is CharacterClass Then Return clsCharacterClass
	If V Is Range Then Return clsRange
	If V Is NamedRange Then Return clsNamedRange
	If V Is Set Then Return clsSet
	If V Is IntersectingSet Then Return clsIntersectingSet
	If V Is Counter Then Return clsCounter
	If V Is Group Then Return clsGroup
	If V Is Boundary Then Return clsBoundary
	If V Is OrClause Then Return clsOrClause
	Return V
End Sub

Private Sub CurrentNode As TreeNode
  Return NodeStack.Get(NodeStack.Size - 1)	
End Sub

Private Sub PushNode(ANode As TreeNode)
	'If NodeStack.Size > 0 Then Log($"Before push, current node: ${CurrentNode.Name}"$)
	NodeStack.Add(ANode)
	'Log($"After push, current node: ${CurrentNode.Name}"$)
End Sub

Private Sub PullNode
	'Log($"Before pull, current node: ${CurrentNode.Name}"$)
	NodeStack.RemoveAt(NodeStack.Size - 1)
	'Log($"After pull, current node: ${CurrentNode.Name}"$)
End Sub

Private Sub CreateNode(Name As String, Value As Object) As TreeNode
	Dim Result As TreeNode 
	Result.Initialize
	Result.Name = Name.Trim
	Result.Value = Value
	Result.Contents.Initialize
	Return Result
End Sub

Private Sub CopyNode(N As TreeNode) As TreeNode
	Dim Result As TreeNode = CreateNode(N.Name, Null)
	Result.Value = CopyNodeValue(N.Value)
	CopyNodes(N.Contents, Result.Contents)
	Return Result
End Sub

Private Sub CopyNodes(Source As List, Target As List)
	For Each N As TreeNode In Source
		Dim N2 As TreeNode = CreateNode(N.Name, CopyNodeValue(N.Value))
		Target.Add(N2)
		CopyNodes(N.Contents, N2.Contents)
	Next
End Sub

Private Sub CopyNodeValue(Value As Object) As Object
	If Value Is String Then Return Value
	If Value Is CharacterClass Then Return CopyTCharacterClass(Value)
	If Value Is Range Then Return CopyTRange(Value)
	If Value Is NamedRange Then Return CopyTNamedRange(Value)
	If Value Is Set Then Return CopyTSet(Value)
	If Value Is IntersectingSet Then Return CopyTIntersectingSet
	If Value Is Counter Then Return CopyTCounter(Value)
	If Value Is Group Then Return CopyTGroup(Value)
	If Value Is Boundary Then Return CopyTBoundary(Value)
	If Value Is OrClause Then Return CopyTOrClause(Value)
	Return ""
End Sub

Private Sub AddToNode(Parent As TreeNode, ANode As TreeNode) As TreeNode
  Parent.Contents.Add(ANode)		
	FlatList.Add(ANode)
	Return ANode
End Sub

Private Sub AddToCurrent(ANode As TreeNode) As TreeNode
	Return AddToNode(CurrentNode, ANode)
End Sub

Private Sub FindNode(Name As String, MustBeOnStack As Boolean) As TreeNode
	Name = Name.Trim
	Dim N As TreeNode
  For i = FlatList.Size - 1 To 0 Step -1
	  N = FlatList.Get(i)
		If N.Name.EqualsIgnoreCase(Name) Then
			If Not(MustBeOnStack) Then Return N 		
			If NodeStack.IndexOf(N) > -1 Then Return N
		End If
  Next
	Return InvalidNode
End Sub

Private Sub FindNodeClass(Class As String, Subclass As Object, MustBeOnStack As Boolean) As TreeNode
	Class = Class.Trim	
	Dim N As TreeNode
	For i = FlatList.Size - 1 To 0 Step -1
		N = FlatList.Get(i)
		If SameClass(N, Class, Subclass) Then
			If Not(MustBeOnStack) Then Return N
			If NodeStack.IndexOf(N) > -1 Then Return N
		End If
	Next
	Return InvalidNode
End Sub

Private Sub FindNamedNodeClass(Name As String, Class As String, Subclass As Object, MustBeOnStack As Boolean) As TreeNode
	Name = Name.Trim
	Class = Class.Trim
	Dim N As TreeNode
	For i = FlatList.Size - 1 To 0 Step -1
		N = FlatList.Get(i)
		If N.Name.EqualsIgnoreCase(Name) And SameClass(N, Class, Subclass) Then
			If Not(MustBeOnStack) Then Return N
			If NodeStack.IndexOf(N) > -1 Then Return N
		End If
	Next
	Return InvalidNode
End Sub

Private Sub SameClass(N As TreeNode, Class As String, Subclass As Object) As Boolean
	If Not(NodeClass(N).EqualsIgnoreCase(Class)) Then Return False
	If Class.EqualsIgnoreCase(clsGroup) Then 
		Return N.Value.As(Group).GroupType.Value = Subclass
	Else If Class.EqualsIgnoreCase(clsBoundary) Then
		Return N.Value.As(Boundary).BoundaryType.Value =Subclass
	End If
	Return True
End Sub

Private Sub Copy(Name As String, Class As String, Subclass As Object) As TreeNode
	Dim N As TreeNode = FindNamedNodeClass(Name, Class, Subclass, False)
	If N.Name = InvalidName Then
		'Raise hell
		Return InvalidNode
	End If
	Dim Result As TreeNode = CopyNode(N)
	AddToCurrent(Result)
	Return Result
End Sub

Public Sub BeginNamed(Name As String) As RegexConstructor
	Dim N As TreeNode = FindNode(Name, False)
	If N.Name = InvalidName Then
		'Raise hell
		Return Me
	End If
	PushNode(AddToCurrent(CopyNode(N)))
	Return Me
End Sub

Private Sub PullToNode(N As TreeNode) As RegexConstructor
	Do While CurrentNode <> N
		If CurrentNode = Tree Then
			'Raise hell
			Exit
		End If
		PullNode
	Loop
	PullNode
	Return Me
End Sub

Private Sub EndClass(Class As String, Subclass As Object) As RegexConstructor
	Dim N As TreeNode = FindNodeClass(Class, Subclass, True)
	If N.Name = InvalidName Then
		'Raise hell
		Return Me
	End If
	Return PullToNode(N)
End Sub

Private Sub EndNamedClass(Name As String, Class As String, Subclass As Object) As RegexConstructor
	Dim N As TreeNode = FindNamedNodeClass(Name, Class, Subclass, True)
	If N.Name = InvalidName Then
		'Raise hell
		Return Me
	End If
	Return PullToNode(N)
End Sub

#End Region

#Region Public functions

#Region Charecters, charcter classes and text

'Returns a string of multiple strings repeated in it.
Private Sub Multiple(s As String, Count As Int) As String
	If s.Length = 0 Then Return ""
	Dim sb As StringBuilder
	sb.Initialize
	For i = 1 To Count
		sb.Append(s)
	Next
	Return sb.ToString
End Sub

Public Sub AddText(Name As String, Value As String) As RegexConstructor 'Escaped
	AddToCurrent(CreateNode(Name, Value))
	Return Me
End Sub

Public Sub Add(Text As String, Count As Int) As RegexConstructor 'Escaped
	Return AddText("", Multiple(Text, Count))
End Sub

Public Sub AddCharacters(Value As String, Count As Int) As RegexConstructor 'Escaped
	Return Add(Value, Count)
End Sub

Public Sub AddCharacterClass(ClassType As CharacterClassType, Count As Int) As RegexConstructor 'Not escaped
	AddToCurrent(CreateCharacterClassNode(ClassType.Description, CreateCharacterClassValue(ClassType, Count)))
	Return Me
End Sub

#End Region

#Region Ranges and sets

Public Sub AddRange(First As String, Last As String) As RegexConstructor
	AddToCurrent(CreateRangeNode("", First, Last))
	Return Me
End Sub

Public Sub AddNamedRange(RangeType As NamedRangeType, Exclude As Boolean) As RegexConstructor
	AddToCurrent(CreateNamedRangeNode(RangeType.Description, RangeType, Exclude))
	Return Me
End Sub

Public Sub BeginSet(Name As String, Exclude As Boolean) As RegexConstructor
	PushNode(AddToCurrent(CreateSetNode(Name, Exclude)))
	Return Me
End Sub

Public Sub EndSet As RegexConstructor
	Return EndClass(clsSet, -1)
End Sub

Public Sub EndNamedSet(Name As String) As RegexConstructor
	Return EndNamedClass(Name, clsSet, -1)
End Sub

Public Sub CopySet(Name As String, Exclude As Boolean) As RegexConstructor
	Dim N As TreeNode = Copy(Name, clsSet, -1)
	If N = InvalidNode Then
		
	End If
	N.Value.As(Set).Exclude = Exclude
	Return Me
End Sub

Public Sub BeginIntersectingSet(Name As String) As RegexConstructor
	PushNode(AddToCurrent(CreateIntersectingSetNode(Name)))
	Return Me
End Sub

Public Sub EndIntersectingSet As RegexConstructor
	Return EndClass(clsIntersectingSet, -1)
End Sub

Public Sub EndNamedIntersectingSet(Name As String) As RegexConstructor
	Return EndNamedClass(Name, clsIntersectingSet, -1)
End Sub

Public Sub CopyIntesectingSet(Name As String) As RegexConstructor
	Dim N As TreeNode = Copy(Name, clsIntersectingSet, -1)
	If N = InvalidNode Then
		
	End If
	Return Me
End Sub

#End Region

#Region Counter

Public Sub BeginQty(Name As String, Minimum As Int, Maximum As Int, Behaviour As QtyBehavior) As RegexConstructor
	PushNode(AddToCurrent(CreateCounterNode(Name, Minimum, Maximum, Behaviour)))
	Return Me
End Sub

Public Sub EndQty As RegexConstructor
	Return EndClass(clsCounter, -1)
End Sub

Public Sub EndNamedQty(Name As String) As RegexConstructor
	Return EndNamedClass(Name, clsCounter, -1)
End Sub

Public Sub CopyQty(Name As String, Minimum As Int, Maximum As Int, Behaviour As QtyBehavior) As RegexConstructor
	Dim N As TreeNode = Copy(Name, clsCounter, -1)
	If N = InvalidNode Then
		
	End If
	Dim c As Counter = N.Value
	If Minimum <> QtyKeepIntact Then c.Minimum = Minimum
	If Maximum <> QtyKeepIntact Then c.Maximum = Maximum
	If Behaviour <> QtyBehaviorKeepIntact Then c.Lazy = Behaviour
	Return Me
End Sub

#End Region

#Region Groups

Public Sub BeginGrp(Name As String, GroupType As GroupType) As RegexConstructor
	PushNode(AddToCurrent(CreateGroupNode(Name, GroupType, QtyUndefined, QtyUndefined)))
	Return Me
End Sub

Public Sub EndGrp As RegexConstructor
	Return EndClass(clsGroup, -1)
End Sub

Public Sub EndNamedGroup(Name As String) As RegexConstructor
	Return EndNamedClass(Name, clsGroup, -1)
End Sub

Public Sub CopyGroup(Name As String, GroupType As GroupType) As RegexConstructor
	Dim N As TreeNode = Copy(Name, clsGroup, -1)
	If N = InvalidNode Then
		
	End If
	N.Value.As(Group).GroupType = GroupType
	Return Me
End Sub

Public Sub BeginCountedLookBehindGroup(Name As String, Minimum As Int, Maximum As Int) As RegexConstructor
	PushNode(AddToCurrent(CreateGroupNode(Name, GrpCountedLookBehind, Minimum, Maximum)))
	Return Me
End Sub

Public Sub EndCountedLookBehindGroup As RegexConstructor
	Return EndClass(clsGroup, GrpCountedLookBehind)
End Sub

Public Sub EndNamedCountedLookBehindGroup(Name As String) As RegexConstructor
	Return EndNamedClass(Name, clsGroup, GrpCountedLookBehind)
End Sub

Public Sub CopyCountedLookBehindGroup(Name As String, GroupType As GroupType) As RegexConstructor
	Dim N As TreeNode = Copy(Name, clsGroup, GrpCountedLookBehind)
	If N = InvalidNode Then
		
	End If
	N.Value.As(Group).GroupType = GroupType
	Return Me
End Sub

#End Region

#Region Boundaries, Or

Public Sub AddWordBoundary As RegexConstructor
  AddToCurrent(CreateBoundaryNode("", BndWord))	
	Return Me
End Sub

Public Sub BeginWordBoundary(Name As String) As RegexConstructor
	PushNode(AddToCurrent(CreateBoundaryNode(Name, BndWord)))
	Return Me
End Sub

Public Sub EndWordBoundary As RegexConstructor
	Return EndClass(clsBoundary, BndWord)
End Sub

Public Sub EndNamedWordBoundary(Name As String) As RegexConstructor
	Return EndNamedClass(Name, clsBoundary, BndWord)
End Sub

Public Sub CopyWordBoundary(Name As String) As RegexConstructor
	Dim N As TreeNode = Copy(Name, clsBoundary, BndWord)
	If N = InvalidNode Then
		
	End If
	Return Me
End Sub

Public Sub AddOr As RegexConstructor
  AddToCurrent(CreateOrNode("", True))
	Return Me	
End Sub

Public Sub BeginOr(Name As String) As RegexConstructor
	PushNode(AddToCurrent(CreateOrNode(Name, False)))
	Return Me
End Sub

Public Sub EndOr As RegexConstructor
	Return EndClass(clsOrClause, -1)
End Sub

Public Sub EndNamedOr(Name As String) As RegexConstructor
	Return EndNamedClass(Name, clsOrClause, -1)
End Sub

Public Sub CopyOr(Name As String) As RegexConstructor
	Dim N As TreeNode = Copy(Name, clsOrClause, -1)
	If N = InvalidNode Then
		
	End If
	Return Me
End Sub

#End Region

#End Region
